package com.crm.web.dao.repository;

import com.crm.rely.backend.dao.repository.BaseRepository;
import com.crm.rely.backend.model.pojo.table.WebCustomAnalysisInteractionHistoryTable;
import org.springframework.data.jpa.repository.Lock;
import org.springframework.stereotype.Repository;

import javax.persistence.LockModeType;
import java.util.List;

@Repository
public interface WebCustomAnalysisInteractionHistoryRepository extends BaseRepository<WebCustomAnalysisInteractionHistoryTable> {

    @Lock(LockModeType.PESSIMISTIC_WRITE)
    WebCustomAnalysisInteractionHistoryTable findFirstById(Long id);

    WebCustomAnalysisInteractionHistoryTable getFirstById(Long id);

    @Lock(LockModeType.PESSIMISTIC_WRITE)
    List<WebCustomAnalysisInteractionHistoryTable> findAllByIdIn(List<Long> ids);

    List<WebCustomAnalysisInteractionHistoryTable> getAllByIdNotIn(List<Long> ids);

    boolean existsByCustomIdAndAnalysisId(Long customId, Long analysisId);
}
